# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import gtk, gobject, base64, marshal, gnome

import TAB, WIDGET, Label, State, \
	Dialog, GConf, Conf, Menu, child, \
	func, Panel, UID

import i18n
_ = i18n.gettext()

class VEE (WIDGET.WIDGET) :

	UID = None

	LIST_TAB = list()
	NOTEBOOK = None

	STATE = None
	IS_LOGO = True

	Toolbar = None
	Menubar = None

	ARGS_OPTIONS = dict()
	ARGS_ARGS = list()

	ENTRY_EXTERNAL_COMMAND = None
	LISTSTORE_EXTERNAL_COMMAND = None

	LIST_TAB_SHORTCUT = dict()

	ID_EVENT_SOURCE = None
	TIME_TIMEOUT = 1000*60
	IS_RUNNING_SCREENSAVER = False
	ID_HANDLER_SCREENSAVER = None

	def __init__ (self, **kwargs) :

		self.STATE = State.State()

		# set uid.
		self.UID = UID.get()
		self.STATE.set_value("uid", self.UID)

		# parse arguments and options.
		if kwargs.has_key("args_options") :
			self.ARGS_OPTIONS = kwargs["args_options"]

		if kwargs.has_key("args_args") :
			self.ARGS_ARGS = kwargs["args_args"]

		handler = { \
			"on_new_vee" : self.on_new_vee, \
			\
			"on_insert_vim" : self.on_insert_vim, \
			"on_insert_gvim" : self.on_insert_gvim, \
			"on_insert_terminal" : self.on_insert_terminal, \
			"on_external_command" : self.on_external_command, \
			\
			"on_open_file_dialog" : self.on_open_file_dialog, \
			"on_show_tab_list" : self.on_show_tab_list, \
			"on_external_command_dialog" : \
				self.on_external_command_dialog, \
			\
			"on_next_tab" : self.on_next_tab, \
			"on_previous_tab" : self.on_previous_tab, \
			\
			"on_remove_page" : self.on_remove_page, \
			\
			"on_toggle_toolbar" : self.on_toggle_toolbar, \
			"on_toggle_menubar" : self.on_toggle_menubar, \
			"on_toggle_bookmark" : self.on_toggle_bookmark, \
			"on_toggle_statusbar" : self.on_toggle_statusbar, \
			\
			"on_preferences" : self.on_preferences, \
			"on_help" : self.on_help, \
			"on_help_keyboard_shortcut" : self.on_help_keyboard_shortcut, \
			"on_about" : self.on_about, \
			\
			"on_quit_all" : self.on_quit_all, \
		}

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.set_path(Conf.LOCAL_ROOT)
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		WIDGET.WIDGET.__init__(self, "vee", None, handler)
		self.__set_geometry()

		self.WIDGET_SELF.set_title(_("vee"))

		__callback_functions = {"addPage" : self.addPage}

		##############################################################
		# ACCELERATORS
		# create accelerator group.
		self.AccelGrpGlobal = gtk.AccelGroup()
		self.AccelGrpWhenHideMenubar = gtk.AccelGroup()

		# register global keyboard shortcut.
		self.WIDGET_SELF.add_accel_group(self.AccelGrpGlobal)
		self.WIDGET_SELF.add_accel_group(self.AccelGrpWhenHideMenubar)

		self.__activate_accelerator( \
			self.AccelGrpGlobal, Conf.KEYBOARD_SHORTCUT_GLOBAL)
		self.__activate_accelerator( \
			self.AccelGrpWhenHideMenubar, \
			Conf.KEYBOARD_SHORTCUT_WHEN_HIDE_MENUBAR)

		##############################################################
		# set event
		self.WIDGET_SELF.set_events(gtk.gdk.KEY_RELEASE)
		self.WIDGET_SELF.add_events(gtk.gdk.KEY_RELEASE)

		# set event.
		EventBox_Notebook = self.xml.get_widget("eventbox1")
		EventBox_Notebook.connect("event", self.on_show_logo)
		EventBox_Notebook.connect( \
			"key-release-event", self.on_prevent_key_intercept)

		self.STATE.set_value("toggled-statusbar", not self.ARGS_OPTIONS.ARG_SHOW_STATUSBAR)
		self.STATE.set_value("toggled-toolbar", not self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR)
		self.STATE.set_value("toggled-menubar", not self.ARGS_OPTIONS.ARG_SHOW_MENUBAR)
		self.STATE.set_value("toggled-bookmark", not self.ARGS_OPTIONS.ARG_SHOW_BOOKMARK)

		# add notification using GConf.
		gconf_notify = GConf.Notify( \
			callback_functions=__callback_functions, \
			state=self.STATE \
		)
		gconf_notify.add()

		##################################################################
		# set the widget initializing.
		self.NOTEBOOK = self.xml.get_widget("notebook1")

		# status bar.
		STATUSBAR = Label.Statusbar(self.xml.get_widget("statusbar1"))
		STATUSBAR.clean()
		self.STATE.set_value("statusbar", STATUSBAR)

		# toolbar and menubar
		self.Toolbar = self.xml.get_widget("toolbar1")
		self.Menubar = self.xml.get_widget("hbox1")
		self.Statusbar = self.xml.get_widget("statusbar1")

		# bookmark panel
		self.PANEL_BOOKMARK = self.xml.get_widget("vbox11")

		##################################################################
		# NOTEBOOK
		# set tab position
		__tab_position =  \
			self.GCONF_CLIENT.get_value_by_conf("tab-position")
		if __tab_position == "Top" :
			__pos = gtk.POS_TOP
		elif __tab_position == "Bottom" :
			__pos = gtk.POS_BOTTOM
		elif __tab_position == "Left" :
			__pos = gtk.POS_LEFT
		elif __tab_position == "Right" :
			__pos = gtk.POS_RIGHT
		else : # default
			__pos = gtk.POS_BOTTOM

		self.NOTEBOOK.set_property("tab-pos", __pos)

		self.NOTEBOOK.remove_page(0)
		self.NOTEBOOK.popup_disable()
		self.NOTEBOOK.connect_after( \
			"switch-page", self.on_notebook_switch_page)

		# store information into state
		self.STATE.set_value("root-widget", self.WIDGET_SELF)
		self.STATE.set_value("notebook", self.NOTEBOOK)
		self.STATE.set_value("tab-list", self.LIST_TAB)

		if not self.GCONF_CLIENT.get_value_by_conf("show-toolbar") :
			self.Toolbar.hide()

		if not self.GCONF_CLIENT.get_value_by_conf("show-menubar") :
			self.Menubar.hide()

		# get window size, and set the position of ruler of paned widget
		# to the half of window height.
		#(w, h) = self.WIDGET_SELF.get_size()
		#__vpaned = self.xml.get_widget("vpaned1")
		#__vpaned.set_position(400)

		if not self.GCONF_CLIENT.get_value_by_conf("show-bookmark") :
			self.PANEL_BOOKMARK.hide()

		self.STATE.set_value("panel-bookmark", self.PANEL_BOOKMARK)
		self.STATE.set_value("toolbar", self.Toolbar)
		self.STATE.set_value("menubar", self.Menubar)

		# external command entry.
		ENTRY_EXTERNAL_COMMAND = \
			self.xml.get_widget("comboboxentry2").child
		ENTRY_EXTERNAL_COMMAND.connect("activate", self.on_external_command)
		__completion = gtk.EntryCompletion()
		ENTRY_EXTERNAL_COMMAND.set_completion(__completion)
		self.LISTSTORE_EXTERNAL_COMMAND = gtk.ListStore(gobject.TYPE_STRING)
		__completion.set_model(self.LISTSTORE_EXTERNAL_COMMAND)
		__completion.set_text_column(0)

		# activate popup menu
		self.NOTEBOOK.connect( \
			"button-press-event", \
			Menu.on_show_popup_full, \
			self.WIDGET_SELF, \
			self.STATE, \
			__callback_functions, \
			self.LISTSTORE_EXTERNAL_COMMAND \
		)

		# set menu label name
		self.__set_label_menu()

		###############################################################
		# ACTIVATE dnd.
		self.NOTEBOOK.connect("drag_data_received", self.on_drag_received)
		self.Menubar.connect("drag_data_received", self.on_drag_received)
		self.Toolbar.connect("drag_data_received", self.on_drag_received)

		self.NOTEBOOK.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Menubar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Toolbar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		#########################################################
		# settting for toolbutton.
		__button_gvim = self.xml.get_widget("toolbutton12")

		# hide new window toolbutton.
		__button_new_window = self.xml.get_widget("toolbutton13")
		__button_new_window.hide()

		__button_vim = self.xml.get_widget("toolbutton1")
		__button_terminal = self.xml.get_widget("toolbutton8")
		__openfile_button = self.xml.get_widget("toolbutton5")
		__next_tab_button = self.xml.get_widget("toolbutton9")
		__perv_tab_button = self.xml.get_widget("toolbutton10")
		__command_label = self.xml.get_widget("toolbutton14")
		__command_label.set_label(_("Run Command"))

		# connect signal for toolbutton.
		__button_vim.connect( \
			"drag_data_received", self.on_drag_received_button_vim)
		__button_vim.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		__button_gvim.connect( \
			"drag_data_received", self.on_drag_received_button_gvim)
		__button_gvim.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		__button_terminal.connect( \
			"drag_data_received", self.on_drag_received_button_terminal)
		__button_terminal.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		# whether child's buttons set visible or not.
		__command_gvim = \
			self.GCONF_CLIENT.get_value_by_conf("command-gvim")

		self.STATE.set_value("vim-button", __button_vim)
		self.STATE.set_value("gvim-button", __button_gvim)
		self.STATE.set_value("terminal-button", __button_terminal)
		if len(__command_gvim.strip()) < 1 :
			__button_gvim.hide()

		for __childname in ("vim", "gvim", "terminal") :
			if not self.GCONF_CLIENT.get_value_by_conf( \
					"use-%s" % __childname) :
				self.STATE.get_value("%s-button" % __childname).hide()

		# set label of toolbutton
		__button_gvim.set_label(_("GVIM"))
		__button_vim.set_label(_("VIM"))
		__openfile_button.set_label(_("Open File"))
		__button_terminal.set_label(_("Open Terminal"))
		__next_tab_button.set_label(_("Next Tab"))
		__perv_tab_button.set_label(_("Previous Tab"))

		# connect signal
		self.PANEL_BOOKMARK.connect("hide", self.on_notify_bookmark)
		self.PANEL_BOOKMARK.connect("show", self.on_notify_bookmark)

		# set the label of the bookmark toggle button.
		self.on_notify_bookmark()

		# creating Bookmarks
		self.Bookmarks = Panel.Bookmarks( \
			self.xml, \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

		# screensaver.
		notify_id = self.GCONF_CLIENT.CLIENT.notify_add( \
			Conf.SCHEMA["enable-screensaver"]["key"], \
			self.__enable_screensaver \
		)

		self.__enable_screensaver()

		##############################################################
		# apply command line argument options.
		if len(self.ARGS_ARGS) > 0 :
			for i in self.ARGS_ARGS :
				self.addPage("vim", filename=i)
		else :
			if self.ARGS_OPTIONS.ARG_START_WITH_VIM :
				self.addPage("vim")
			if self.ARGS_OPTIONS.ARG_START_WITH_TERMINAL :
				self.addPage("terminal")

		if not self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR : self.Toolbar.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_MENUBAR : self.Menubar.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_BOOKMARK : self.PANEL_BOOKMARK.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_STATUSBAR : self.Statusbar.hide()

		if self.PANEL_BOOKMARK.get_property("visible") :
			bookmark_tree = self.xml.get_widget("treeview2")
			bookmark_tree.grab_focus()

	def __enable_screensaver (self, client=None, parm1=None, parm2=None, parm3=None) :
		return

		if self.GCONF_CLIENT.get_value_by_conf("enable-screensaver") :
			self.TIME_TIMEOUT = \
				self.GCONF_CLIENT.get_value_by_conf("timeout-screensaver")

			self.ID_EVENT_SOURCE = gobject.timeout_add( \
				self.TIME_TIMEOUT, self.__start_screensaver)

			self.ID_HANDLER_SCREENSAVER = self.WIDGET_SELF.connect("event", self.__set_timeout)
		else :
			if self.ID_HANDLER_SCREENSAVER :
				self.WIDGET_SELF.disconnect(self.ID_HANDLER_SCREENSAVER)
				self.__stop_screensaver()

	def __set_timeout (self, parm1, event) :
		if event.type is gtk.gdk.MOTION_NOTIFY : return
		if event.type is gtk.gdk.EXPOSE : return

		self.__stop_screensaver()

		self.ID_EVENT_SOURCE = gobject.timeout_add( \
			self.TIME_TIMEOUT, self.__start_screensaver)

	def __start_screensaver (self) :
		return

		__n = self.NOTEBOOK.get_current_page()
		__egg = self.LIST_TAB[__n].Child
		if __egg.CHILD_TYPE == child.TYPE_VIM :
			__egg.send("\033:Matrix\n")
			__egg.IS_RUNNING_SCREENSAVER = True

	def __stop_screensaver (self) :
		return

		if getattr(self, "ID_EVENT_SOURCE") and type(self.ID_EVENT_SOURCE) is int:
			gobject.source_remove(self.ID_EVENT_SOURCE)

			if self.IS_RUNNING_SCREENSAVER :
				__n = self.NOTEBOOK.get_current_page()
				__egg = self.LIST_TAB[__n].Child
				if __egg.CHILD_TYPE == child.TYPE_VIM :
					__egg.IS_RUNNING_SCREENSAVER = False
					__egg.send("\033")

	# EVENT HANDLER #####################################################
	def on_new_vee (self, widget) :
		main(args_options=self.ARGS_OPTIONS, args_args=self.ARGS_ARGS)

	def on_prevent_key_intercept (self, parm1, parm2) :
		__n = self.NOTEBOOK.get_current_page()
		try :
			self.LIST_TAB[__n].Child.WIDGET.grab_focus()
		except :
			pass

	def __addAccelKeySwitchTab (self) :
		"""
		그놈 터미널이나 에피파니처럼 Alt+숫자키로 탭이동하는 패치.
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용
		"""
		__c = Conf.LIST_KEYBOARD_SHORTCUT["modifier-switch-tab"]

		num = len(self.LIST_TAB_SHORTCUT)
		__key, __mod = gtk.accelerator_parse(__c[0] % (num + 1))

		if self.LIST_TAB_SHORTCUT.has_key(__key) :
			return
		else :
			self.LIST_TAB_SHORTCUT[__key] = num
			self.AccelGrpGlobal.connect_group(__key, __mod, \
				gtk.ACCEL_VISIBLE, eval(__c[1]))

	def on_notebook_switch_page (self, widget, parm1, parm2) :

		if len(self.LIST_TAB) < 1 : return

		# change window title.
		current_page = self.NOTEBOOK.get_current_page()
		try :
			__title = self.LIST_TAB[current_page].Child.get_title()
		except IndexError :
			return
		else :
			self.set_title(__title)

	def on_drag_received_button_vim \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("vim", filename=__path)

	def on_drag_received_button_gvim \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("gvim", filename=__path)

	def on_drag_received_button_terminal \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("terminal", directory=__path)

	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("vim", filename=__path)

	def on_quit_all \
			(self, parm1, parm2=None, parm3=None, parm4=None) :
		Dialog.AskCloseAllTabDialog(self.WIDGET_SELF, self.STATE)

		return True

	def on_external_command_dialog (self, widget) :
		__callback_functions = {"addPage" : self.addPage}
		ExternalCommand( \
			state=self.STATE, \
			callback_functions=__callback_functions, \
			completion_liststore=self.LISTSTORE_EXTERNAL_COMMAND \
		)

	def on_external_command (self, widget) :
		__c = widget.get_text()
		if len(__c.strip()) < 1 : return

		parsed_argv = func.parse_command_line_argument(__c)

		if len(parsed_argv["command"].strip()) < 1 : return

		if not func.is_valid_command(parsed_argv["command"]) :
			NoValidCommand(parsed_argv["command"])
			return

		self.LISTSTORE_EXTERNAL_COMMAND.append([__c, ])
		self.addPage("external_command", external_command=__c.strip())

		# make this be blank.
		widget.set_text("")

	def __window_size_changed (self, widget, parm1) :
		__wh = self.GCONF_CLIENT.get_value_by_conf("latest-window-geometry")

		if len(__wh.split(",")) > 1 :
			__wh0 = [ int(i) for i in __wh.split(",")]
		else :
			__wh0 = (0,0)

		(w, h) = self.WIDGET_SELF.get_size()

		self.GCONF_CLIENT.set_value_by_conf( \
			"latest-window-geometry", \
			"%d,%d,%d,%d" % (w, h, __wh0[2], __wh0[3]) \
		)

	def on_toggle_menubar (self, widget) :
		if self.Menubar.get_property("visible") :
			self.Menubar.hide()
		else :
			self.Menubar.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-menubar")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def on_toggle_toolbar (self, widget) :
		if self.Toolbar.get_property("visible") :
			self.Toolbar.hide()
		else :
			self.Toolbar.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-toolbar")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def on_toggle_statusbar (self, widget) :
		if self.Statusbar.get_property("visible") :
			self.Statusbar.hide()
		else :
			self.Statusbar.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-statusbar")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def on_notify_bookmark (self, widget=None) :
		__label = self.xml.get_widget("label93")
		if self.PANEL_BOOKMARK.get_property("visible") :
			__label.set_label(_("Hide Bookmark Panel (Ctrl+Alt+B)"))
		else :
			__label.set_label(_("Show Bookmark Panel (Ctrl+Alt+B)"))

	def on_toggle_bookmark (self, widget) :
		if self.PANEL_BOOKMARK.get_property("visible") :
			self.PANEL_BOOKMARK.hide()
		else :
			self.PANEL_BOOKMARK.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-bookmark")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def on_show_logo (self, parm1, parm2) :

		if self.NOTEBOOK.get_n_pages() < 1 :
			self.addLogo()

	def on_open_file_dialog (self, widget) :
		__callback_functions = {"addPage" : self.addPage}

		Dialog.FileSelectionDialog( \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

	def on_preferences (self, widget) :
		Preferences()

	def on_help (self, widget) :
		__localedir = i18n.getDirectoryLocale(Conf.DIR_HELP)
		if __localedir is None :
			__localedir = os.path.join(Conf.DIR_HELP, "en")

		__help_file = os.path.join(__localedir, "vee.xml")

		gnome.help_display_uri("ghelp://%s" % __help_file)

	def on_help_keyboard_shortcut (self, widget) :
		__localedir = i18n.getDirectoryLocale(Conf.DIR_HELP)
		if __localedir is None :
			__localedir = os.path.join(Conf.DIR_HELP, "en")

		__help_file = os.path.join(__localedir, "vee.xml")

		gnome.help_display_uri("ghelp://%s#myapp-keyboard-shortcut" % __help_file)

	def on_about (self, widget) :
		About()

	def on_insert_gvim (self, widget) :
		self.addPage("gvim")

	def on_insert_vim (self, widget) :
		self.addPage("vim")

	def on_insert_terminal (self, widget) :
		self.addPage("terminal")

	def on_remove_page (self, widget) :
		current_page = self.NOTEBOOK.get_current_page()
		tab = self.LIST_TAB[current_page]
		tab.Child.exit()
		STATUSBAR.clean()

	def on_next_tab (self, widget) :
		self.NOTEBOOK.next_page()

	def on_previous_tab (self, widget) :
		self.NOTEBOOK.prev_page()

	#########################################################################
	# Accel HANDLER
	def on_show_tab_list (self, widget) :
		if len(self.LIST_TAB) < 2 : return
		TabList(state=self.STATE)

	def ac_show_tab_list (self, widget, parm1, parm2, parm3) :
		if len(self.LIST_TAB) < 2 : return
		TabList(state=self.STATE)

	def ac_toggle_bookmark (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.grab_focus()
		if self.PANEL_BOOKMARK.get_property("visible") :
			self.PANEL_BOOKMARK.hide()
		else :
			self.PANEL_BOOKMARK.show()
			bookmark_tree = self.xml.get_widget("treeview2")
			bookmark_tree.grab_focus()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-bookmark")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def ac_change_nth_tab (self, parm1, parm2, parm3, parm4) :
		"""
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용
		"""
		self.NOTEBOOK.grab_focus()
		__n = self.LIST_TAB_SHORTCUT[parm3]
		if __n == self.NOTEBOOK.get_current_page() : return

		self.NOTEBOOK.set_current_page(__n)

	def ac_font_decrease (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.decrease_font()

	def ac_font_increase (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.increase_font()

	def ac_insert_gvim (self, parm1, parm2, parm3, parm4) :
		self.addPage("gvim")

	def ac_insert_vim (self, parm1, parm2, parm3, parm4) :
		self.addPage("vim")

	def ac_insert_terminal (self, parm1, parm2, parm3, parm4) :
		self.addPage("terminal")

	def ac_fileSelectionDialog  (self, parm1, parm2, parm3, parm4) :
		__callback_functions = {"addPage" : self.addPage}
		Dialog.FileSelectionDialog( \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

	def ac_next_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_previous_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.prev_page()

	def ac_rotate_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_run_on_external_command (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.grab_focus()

		__callback_functions = {"addPage" : self.addPage}
		ExternalCommand( \
			state=self.STATE, \
			callback_functions=__callback_functions, \
			completion_liststore=self.LISTSTORE_EXTERNAL_COMMAND \
		)

	def ac_focus_on_external_command (self, parm1, parm2, parm3, parm4) :
		if self.Toolbar.get_property("visible") :
			__entry = self.xml.get_widget("comboboxentry2").child
			__entry.grab_focus()

	#############################################################
	# etc method.
	def __set_geometry (self) :
		# window size matters.
		__wh = self.GCONF_CLIENT.get_value_by_conf("latest-window-geometry")

		if len(__wh.split(",")) > 1 :
			__wh0 = [ int(i) for i in __wh.split(",")]

			# resize() and set_size_request will change the window size, but
			# set_size_request keep the window from being smaller.
			self.WIDGET_SELF.resize(__wh0[0], __wh0[1])
			#self.WIDGET_SELF.move(__wh0[2], __wh0[3])
			#self.WIDGET_SELF.set_size_request(__wh0[0], __wh0[1])

		if self.ARGS_OPTIONS.ARG_MAXIMIZE_WINDOW :
			self.WIDGET_SELF.maximize()

		self.WIDGET_SELF.connect( \
			"size_request", self.__window_size_changed)

	def __set_label_menu (self) :

		menu_items = ( \
			("file1", _("File"),),
			("Open", _("_Open (Alt+Shift+F)"),),
			("NewVIM", _("_New VIM (Ctrl+Alt+V)"),),
			("new_gvim1", _("New _GVIM (Ctrl+Alt+G)"),),
			("NewTerminal", _("_New Terminal (Ctrl+Alt+Z)"),),
			("new_vee_(ctrl+shift+m)1", _("New VEE (Ctrl+Shift+M)"),),
			("close1", _("_Close"),),
			("quit", _("_Quit (Ctrl+Q)"),),
			#("edit1", _("Edit"),),
			#("edit_profiles1", _("Edit profiles"),),
			("view2", _("_View"),),
			("show_menubar1", _("Toggle show/hide menubar"),),
			("show_toolbar1", _("Toggle show/hide toolbar"),),
			("show_bookmark1", _("Toggle show/hide bookmark"),),
			("show_statusbar1", _("Toggle show/hide statusbar"),),
			("previous_tab1", _("Previous tab (Ctrl+Shift+PgDn)"),),
			("next_tab1", _("Next Tab (Ctrl+Shift+PgUp)"),),
			("increase_fonts2", _("_Increase fonts (Ctrl+=)"),),
			("decrease_fonts2", _("_Decrease fonts (Ctrl+-)"),),
			("preferences1", _("Preferences"),),
			("contents1", _("_Contents"),),
			("keyboard_shortcut1", _("_Keyboard Shortcut"),),
			("help1", _("Help"),),
			("about1", _("About"),),
		)

		for i, j in menu_items :
			__m = self.xml.get_widget(i)
			if __m is None : continue
			__m.get_children()[0].set_label(j)

	def set_title (self, strings) :
		self.WIDGET_SELF.set_title(_("%s : VEE") % strings)

	def reset_child (self, type) :
		if len(self.LIST_TAB) < 1 : return

		for i in self.LIST_TAB :
			if i.Child.CHILD_TYPE == type :
				i.Child.reset()

	def __activate_accelerator \
			(self, accel_group, shortcut_tuple=tuple()) :
		if len(shortcut_tuple) < 1 : return False

		for i in shortcut_tuple :
			__o = Conf.LIST_KEYBOARD_SHORTCUT[i]

			if len(__o) < 2 : continue

			__key, __mod = gtk.accelerator_parse(__o[0])
			accel_group.connect_group(__key, __mod, \
				gtk.ACCEL_VISIBLE, eval(__o[1]))

		return True

	def addLogo (self) :

		Logo = gtk.Image()
		Logo.set_from_file(os.path.join(Conf.DIR_PIXMAPS, "vee-logo.png"))
		Logo.show()

		__eventbox = gtk.EventBox()
		__eventbox.add(Logo)
		__eventbox.show()

		tab = TAB.TAB( \
			state=self.STATE, \
			without_closebutton=True)

		tab.addWidget(__eventbox, _("VEE"))
		self.WIDGET_SELF.set_title(_("vee"))

		self.IS_LOGO = True

	def addPage (self, childname, **kwargs) :
		if self.GCONF_CLIENT.get_value_by_conf( \
				"use-%s" % childname) is False :
			return

		if self.IS_LOGO :
			self.NOTEBOOK.remove_page(0)
			self.IS_LOGO = False

		__tab = child.getTab(childname)
		tab = __tab(self.STATE, **kwargs)

		tab.make()

		self.__addAccelKeySwitchTab()

class NoValidCommand (WIDGET.WIDGET) :

	def __init__ (self, command=str()) :
		WIDGET.WIDGET.__init__(self, "error")

		self.WIDGET_SELF.set_title(_("This command does not exist. Check it out."))

		if command.strip() :
			__label = self.xml.get_widget("label90")
			__label.set_label( \
				_("\n'%s' does not exist. Check it.\n\n") % command \
			)

class TabList (WIDGET.WIDGET) :

	STATE = None
	LIST_TAB = list()
	NOTEBOOK = None

	CURRENT_PAGE = int()

	BOX = None

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")

		self.STATE = kwargs["state"]
		self.LIST_TAB = self.STATE.get_value("tab-list")
		self.NOTEBOOK = self.STATE.get_value("notebook")

		# get current page.
		self.CURRENT_PAGE = self.NOTEBOOK.get_current_page()

		WIDGET.WIDGET.__init__(self, "tablist", None)

		self.__create_list()

		# set label.
		self.WIDGET_SELF.set_title(_("List Tabs."))
		__label = self.xml.get_widget("label101")
		__label.set_label(_("<b>Tab List - Select One.</b>"))

	def __create_list (self) :
		self.BOX = self.xml.get_widget("vbox19")
		__n = 0
		for i in self.LIST_TAB :
			# get the name of each tab.
			__t = i.Child.CHILD_TYPE
			if __t == child.TYPE_TERMINAL :
				__type = "terminal"
				__label = i.Child.DIRECTORY
			elif __t == child.TYPE_EXTERNAL_COMMAND :
				__type = "external_command"
				__label = i.Child.EXTERNAL_COMMAND
			elif __t == child.TYPE_VIM :
				__type = "vim"
				__label = i.Child.FILENAME
			elif __t == child.TYPE_GVIM :
				__type = "gvim"
				__label = i.Child.FILENAME
			else :
				return

			self.append_item(__type, __label, __n + 1)
			__n += 1

		__1st = self.BOX.get_children()[self.CURRENT_PAGE]
		__1st.set_active(True)
		__1st.grab_focus()

	def append_item (self, type, label, seq) :
		__label = gtk.Label(" %d : %s" % (seq, label))
		__image = self.get_icon(type)
		__label.show()
		__image.show()

		__box = gtk.HBox()
		__box.pack_start(__image, expand=False, fill=False)
		__box.pack_start(__label, expand=False, fill=False)
		__box.set_property("homogeneous", False)
		__box.show()

		__button = gtk.ToggleButton()
		__button.add(__box)
		__button.set_data("seq", seq)
		__button.show()

		__button.connect("focus_out_event", self.on_unselect_item)
		__button.connect("focus_in_event", self.on_select_item)
		__button.connect("event", self.on_select_event)

		self.BOX.pack_start(__button)

	def on_unselect_item (self, widget, event) :
		widget.set_active(False)

	def on_select_item (self, widget, event) :
		widget.set_active(True)

	def on_select_event (self, widget, event) :
		try :
			event.keyval
		except AttributeError :
			return

		if event.keyval == 65293 :
			num_page = widget.get_data("seq") - 1
			self.NOTEBOOK.set_current_page(num_page)

	def get_icon (self, type) :

		if type == "category" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "category.png")
		elif type == "terminal" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "terminal.png")
		elif type == "external_command" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "external-command.png")
		elif type == "vim" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "vim.png")
		elif type == "gvim" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "gvim.png")

		# create category icon image
		__p = gtk.gdk.pixbuf_new_from_file_at_size(__path, 50, 50)
		__i = gtk.Image()
		__i.set_from_pixbuf(__p)

		return __i

class ExternalCommand (WIDGET.WIDGET) :

	ENTRY_EXTERNAL_COMMAND = None
	LISTSTORE = None
	STATE = None
	CALLBACK_FUNCTIONS = dict()
	TREEVIEW_LAST_COMMAND = None

	GCONF_CLIENT = None

	LIST_STORED = list()

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("completion_liststore") :
			raise ValueError, _("completion_liststore must be included.")
		else :
			self.LISTSTORE = kwargs["completion_liststore"]

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]

		if not kwargs.has_key("callback_functions") :
			raise ValueError, _("callback_functions must be included.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		handler = { \
			"on_ok"	: self.on_ok, \
			"on_add_command"	: self.on_add_command, \
			"on_remove_command"	: self.on_remove_command, \
		}

		WIDGET.WIDGET.__init__( \
			self, "external_command", None, handler)

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		self.BOX_LAST_COMMAND = self.xml.get_widget("vbox17")

		__label = self.xml.get_widget("label92")
		__label.set_label(_("Run Command"))

		self.ENTRY_EXTERNAL_COMMAND = self.xml.get_widget("comboboxentry1")
		__completion = gtk.EntryCompletion()
		self.ENTRY_EXTERNAL_COMMAND.child.set_completion(__completion)
		self.ENTRY_EXTERNAL_COMMAND.child.grab_focus()
		self.ENTRY_EXTERNAL_COMMAND.child.connect("activate", self.on_ok)
		self.ENTRY_EXTERNAL_COMMAND.child.connect( \
			"changed", self.on_changed_entry)

		__completion.set_model(self.LISTSTORE)
		__completion.set_text_column(0)

		# saved command list.
		self.EXPANDER = self.xml.get_widget("expander1")
		self.EXPANDER.connect("notify::expanded", self.expander_callback)

		__state_expander = \
			self.STATE.get_value("run-command-expander-state", False)
		self.EXPANDER.set_expanded(__state_expander)

		self.WIDGET_SELF.set_title(_("Run Command"))

		# buttons
		self.BUTTON_ADD = self.xml.get_widget("button_add")
		self.BUTTON_ADD.set_property("sensitive", False)
		self.BUTTON_REMOVE = self.xml.get_widget("button_remove")
		self.BUTTON_REMOVE.set_property("sensitive", False)

		__label_items = { \
			"label96" : _("Saved commands."), \
			"label97" : _("Add"), \
			"label98" : _("Remove"), \
		}

		for i, j in __label_items.items() :
			self.xml.get_widget(i).set_label(j)

		self.__load_list()
		self.__create_treeview()

	def __load_list (self) :

		# get the stored list of external command list.
		__data = self.GCONF_CLIENT.get_value_by_conf("external-command-list")

		__data0 = base64.decodestring(__data)
		__data1 = marshal.loads(__data0)

		if type(__data1) is list :
			self.LIST_STORED = __data1

	def __store_list (self) :
		__data = marshal.dumps(self.LIST_STORED)
		__data0 = base64.encodestring(__data)

		self.GCONF_CLIENT.set_value_by_conf( \
			"external-command-list", \
			__data0 \
		)

	def __store_item (self, command) :
		self.LIST_STORED.append(command)
		self.__store_list()

	def on_changed_entry (self, widget) :
		__d = widget.get_text().strip()

		if len(__d) < 1 :
			self.BUTTON_ADD.set_property("sensitive", False)
		else :
			self.BUTTON_ADD.set_property("sensitive", True)

	def __create_treeview (self) :
		self.TREEVIEW_LAST_COMMAND = self.xml.get_widget("treeview3")
		self.TREEVIEW_LAST_COMMAND.set_headers_visible(False)

		# connect signal
		self.TREEVIEW_LAST_COMMAND.connect( \
			"cursor-changed", self.on_select_command)
		self.TREEVIEW_LAST_COMMAND.connect( \
			"row-activated", self.on_ok)

		# create a CellRenderers to render the data
		tvcolumn = gtk.TreeViewColumn("")
		tvcolumn.set_expand(True)
		tvcolumn.set_sort_column_id(0)

		self.LISTSTORE = gtk.ListStore(str)
		self.TREEVIEW_LAST_COMMAND.set_model(self.LISTSTORE)
		self.TREEVIEW_LAST_COMMAND.append_column(tvcolumn)

		# add the cells to the columns - 2 in the first
		cell = gtk.CellRendererText()
		tvcolumn.pack_start(cell, True)
		tvcolumn.set_attributes(cell, text=0)

		self.TREEVIEW_LAST_COMMAND.set_reorderable(True)

		for i in self.LIST_STORED :
			self.__append_command(i)

	def __append_command (self, command) :
		if not command.strip() : return

		self.LISTSTORE.append(("%s" % command,))
		return

	def on_select_command (self, widget) :
		__tree_selection = self.TREEVIEW_LAST_COMMAND.get_selection()
		(__tree_store, __tree_iter) = __tree_selection.get_selected()
		try :
			__value = self.LISTSTORE.get_value(__tree_iter, 0)
		except TypeError :
			return

		self.ENTRY_EXTERNAL_COMMAND.child.set_text(__value)
		self.BUTTON_REMOVE.set_property("sensitive", True)

	def on_add_command (self, widget) :
		__c = self.ENTRY_EXTERNAL_COMMAND.child.get_text()
		if len(__c.strip()) < 1 : return

		self.__append_command(__c)
		# after add in tree, make entry to be blank.
		self.ENTRY_EXTERNAL_COMMAND.child.set_text("")

		self.__store_item(__c)

	def on_remove_command (self, widget) :
		__tree_selection = self.TREEVIEW_LAST_COMMAND.get_selection()
		(__tree_store, __tree_iter) = __tree_selection.get_selected()
		try :
			__path = self.LISTSTORE.get_path(__tree_iter)
		except TypeError :
			return

		self.LISTSTORE.remove(__tree_iter)
		self.ENTRY_EXTERNAL_COMMAND.child.set_text("")

		del(self.LIST_STORED[__path[0]])
		self.__store_list()

	def expander_callback(self, expander, param_spec, user_data=None):
		if expander.get_expanded():
			self.BOX_LAST_COMMAND.show()
			self.WIDGET_SELF.set_property("resizable", True)
		else:
			self.BOX_LAST_COMMAND.hide()
			self.WIDGET_SELF.set_property("resizable", False)

		self.STATE.set_value( \
			"run-command-expander-state", expander.get_expanded())

	def on_ok (self, widget, parm1=None, parm2=None) :
		__c = self.ENTRY_EXTERNAL_COMMAND.child.get_text()
		if len(__c.strip()) < 1 : return

		parsed_argv = func.parse_command_line_argument(__c)

		if len(parsed_argv["command"].strip()) < 1 : return

		if not func.is_valid_command(parsed_argv["command"]) :
			NoValidCommand(parsed_argv["command"])
			return

		self.LISTSTORE.append([__c, ])
		__func = self.CALLBACK_FUNCTIONS["addPage"]
		__func("external_command", external_command=__c.strip())

		self.on_close(widget)

class About (WIDGET.WIDGET) :
	"""
	 "authors"              GValueArray           : Write
	 "comments"             gchararray            : Read / Write
	 "copyright"            gchararray            : Read / Write
	 "documenters"          GValueArray           : Write
	 "logo"                 GdkPixbuf             : Write
	 "name"                 gchararray            : Read / Write
	 "translator-credits"   gchararray            : Read / Write
	 "version"              gchararray            : Read / Write
	"""

	def __init__ (self) :
		WIDGET.WIDGET.__init__(self, "about")

		for i, j in Conf.INFO.items() :
			self.WIDGET_SELF.set_property(i, _(j))

	def on_ok (self, widget) :
		self.on_close(widget)

class Preferences (WIDGET.WIDGET) :

	GCONF_CLIENT = None

	FONT_DEFAULT_SYSTEM = str()

	TAB_POSITION = ("Bottom", "Top", "Left", "Right")

	def __init__ (self) :

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		handler = { \
			"on_use_system_font" : self.on_use_system_font, \
			"on_font_set_vim" : self.on_font_set_vim, \
			"on_font_set_terminal" : self.on_font_set_terminal, \
			"on_toggle_menubar" : self.on_toggle_menubar, \
			"on_toggle_toolbar" : self.on_toggle_toolbar, \
			"on_toggle_statusbar" : self.on_toggle_statusbar, \
			"on_toggle_bookmark" : self.on_toggle_bookmark, \
			"on_change_vim" : self.on_change_vim, \
			"on_change_gvim" : self.on_change_gvim, \
			"on_change_terminal" : self.on_change_terminal, \
			"on_change_max_scrollline" : self.on_change_max_scrollline, \
			"on_change_tab_position" : self.on_change_tab_position, \
			"on_enable_screensaver" : self.on_enable_screensaver, \
			"on_change_timeout_screensaver" :
					self.on_change_timeout_screensaver, \
			"on_not_use_vim" : self.on_not_use_vim, \
			"on_not_use_gvim" : self.on_not_use_gvim, \
			"on_not_use_terminal" : self.on_not_use_terminal, \
		}

		WIDGET.WIDGET.__init__(self, "preferences", None, handler)

		############################################################
		# get widget
		__checkbutton_hide_menubar = self.xml.get_widget("checkbutton13")
		__checkbutton_hide_toolbar = self.xml.get_widget("checkbutton14")
		__checkbutton_hide_bookmark = self.xml.get_widget("checkbutton15")
		__checkbutton_set_screensaver = self.xml.get_widget("checkbutton17")
		__checkbutton_hide_statusbar = self.xml.get_widget("checkbutton18")

		__widget_font_vim = self.xml.get_widget("fontbutton3")
		__widget_font_terminal = self.xml.get_widget("fontbutton4")
		__widget_font_system_default = self.xml.get_widget("checkbutton12")
		__widget_command_vim = self.xml.get_widget("entry13")
		__widget_command_gvim = self.xml.get_widget("entry16")
		__widget_command_terminal = self.xml.get_widget("entry14")
		__widget_max_scrollline = self.xml.get_widget("spinbutton1")

		####################################################################
		# set label name
		__label_items = { \
			"checkbutton13" : _("Show menubar"), \
			"checkbutton14" : _("Show toolbar"), \
			"checkbutton18" : _("Show statusbar"), \
			"checkbutton15" : _("Show bookmark"), \
			"checkbutton12" : _("Use gnome default terminal font."), \
			"label75" : _("VIM Font : "), \
			"label76" : _("Terminal Font : "), \
			"label51" : _("Main"), \
			"label59" : _("Command"), \
			"label88" : _("Terminal"), \
			"label77" : _("VIM Command : "), \
			"label78" : _("Terminal Command : "), \
			"label91" : _("GVIM Command : "), \
			"label50" : _("<b>Main</b>"), \
			"label58" : _("<b>Command</b>"), \
			"label89" : _("Maximum line number to scroll : "), \
			"label102" : _("<b>Fonts</b>"), \
			"label104" : _("Foreground : "), \
			"label105" : _("Background : "), \
			"label106" : _("Dim : "), \
			"label107" : _("Highlight : "), \
			"label108" : _("Cursor : "), \
			"label111" : _("Fonts"), \
			"label113" : _("Colors"), \
			"label115" : _("<b>Layout</b>"), \
			"label116" : _("Tab position : "), \
			"label117" : _("VIM"), \
			"label119" : _("Set Timeout : "), \
			"label120" : _("M"), \
			"label121" : _("* You need to restart VEE."), \
			"checkbutton19" : _("Not Use?"), \
			"checkbutton20" : _("Not Use?"), \
			"checkbutton21" : _("Not Use?"), \
			"checkbutton17" : _("Enable ScreenSaver?"), \
		}

		for i, j in __label_items.items() :
			self.xml.get_widget(i).set_label(j)

		__spin = self.xml.get_widget("spinbutton2")
		__timeout = self.GCONF_CLIENT.get_value_by_conf("timeout-screensaver")

		if type(__timeout) is int and __timeout > 1000 :
			__timeout_value = int(__timeout / (1000*60))
		else :
			__timeout_value = int(Conf.SCHEMA["timeout-screensaver"]["default"] / (1000*60))

		__spin.set_value(__timeout_value)

		if self.GCONF_CLIENT.get_value_by_conf("enable-screensaver") :
			__checkbutton_set_screensaver.set_active(True)
		else :
			__checkbutton_set_screensaver.set_active(False)
			__spin.set_sensitive(False)

		# set default system font.
		self.FONT_DEFAULT_SYSTEM = self.GCONF_CLIENT.get_value( \
				Conf.GLOBAL_FONT_SYSTEM_DEFAULT)

		# set tab position
		__tab_position =  \
			self.GCONF_CLIENT.get_value_by_conf("tab-position")
		__tp = self.xml.get_widget("combobox3")
		for i in range(len(self.TAB_POSITION)) :
			__tp.insert_text(i, _(self.TAB_POSITION[i]))

		try :
			__position = list(self.TAB_POSITION).index(__tab_position)
		except ValueError :
			__position = 0

		__tp.set_active(__position)

		# set font name
		__fontname_vim = self.GCONF_CLIENT.get_value_by_conf("font-vim")
		__fontname_terminal = \
			self.GCONF_CLIENT.get_value_by_conf("font-terminal")

		if __fontname_vim :
			__widget_font_vim.set_font_name(__fontname_vim)

		if __fontname_terminal :
			__widget_font_terminal.set_font_name(__fontname_terminal)

		__use_system_default_font = \
			self.GCONF_CLIENT.get_value_by_conf("use-system-default-font")

		if __use_system_default_font :
			__widget_font_vim.set_sensitive(False)
			__widget_font_terminal.set_sensitive(False)
			__widget_font_system_default.set_active(True)
		else :
			__widget_font_system_default.set_active(False)

		# show/hide menubar, toolbar, bookmark
		__show_menubar = \
			self.GCONF_CLIENT.get_value_by_conf("show-menubar")
		__checkbutton_hide_menubar.set_active(__show_menubar)

		__show_toolbar = \
			self.GCONF_CLIENT.get_value_by_conf("show-toolbar")
		__checkbutton_hide_toolbar.set_active(__show_toolbar)

		__show_statusbar = \
			self.GCONF_CLIENT.get_value_by_conf("show-statusbar")
		__checkbutton_hide_statusbar.set_active(__show_statusbar)

		__show_bookmark = \
			self.GCONF_CLIENT.get_value_by_conf("show-bookmark")
		__checkbutton_hide_bookmark.set_active(__show_bookmark)

		__command_vim = self.GCONF_CLIENT.get_value_by_conf("command-vim")
		__command_gvim = self.GCONF_CLIENT.get_value_by_conf("command-gvim")
		__command_terminal = \
			self.GCONF_CLIENT.get_value_by_conf("command-terminal")

		__widget_command_vim.set_text(__command_vim)
		__widget_command_gvim.set_text(__command_gvim)
		__widget_command_terminal.set_text(__command_terminal)

		# max scrollable line
		__value_max_scrollline = \
			self.GCONF_CLIENT.get_value_by_conf("max-scrollline")

		__widget_max_scrollline.set_value(int(__value_max_scrollline))

		# set color
		__colorbutton_foreground = self.xml.get_widget("colorbutton1")
		__colorbutton_foreground.connect( \
			"color-set", self.on_color_changed, "foreground")
		__c = self.GCONF_CLIENT.get_value_by_conf("color-foreground")
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_foreground.set_color(__gdkColor)

		__colorbutton_background = self.xml.get_widget("colorbutton2")
		__colorbutton_background.connect( \
			"color-set", self.on_color_changed, "background")
		__c = self.GCONF_CLIENT.get_value_by_conf("color-background")
		__gdkColor = func.str_to_color(__c, "black")
		__colorbutton_background.set_color(__gdkColor)

		__colorbutton_dim = self.xml.get_widget("colorbutton3")
		__colorbutton_dim.connect( \
			"color-set", self.on_color_changed, "dim")
		__c = self.GCONF_CLIENT.get_value_by_conf("color-dim")
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_dim.set_color(__gdkColor)

		__colorbutton_highlight = self.xml.get_widget("colorbutton4")
		__colorbutton_highlight.connect( \
			"color-set", self.on_color_changed, "highlight")
		__c = self.GCONF_CLIENT.get_value_by_conf("color-highlight")
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_highlight.set_color(__gdkColor)

		__colorbutton_cursor = self.xml.get_widget("colorbutton5")
		__colorbutton_cursor.connect( \
			"color-set", self.on_color_changed, "cursor")
		__c = self.GCONF_CLIENT.get_value_by_conf("color-cursor")
		__gdkColor = func.str_to_color(__c, "red")
		__colorbutton_cursor.set_color(__gdkColor)

		# check the usage of the commands?
		__use_vim = \
			self.GCONF_CLIENT.get_value_by_conf("use-vim")
		__checkbutton_vim = self.xml.get_widget("checkbutton19")
		__checkbutton_vim.set_active(not __use_vim)

		__use_gvim = \
			self.GCONF_CLIENT.get_value_by_conf("use-gvim")
		__checkbutton_gvim = self.xml.get_widget("checkbutton20")
		__checkbutton_gvim.set_active(not __use_gvim)

		__use_terminal = \
			self.GCONF_CLIENT.get_value_by_conf("use-terminal")
		__checkbutton_terminal = self.xml.get_widget("checkbutton21")
		__checkbutton_terminal.set_active(not __use_terminal)

	def on_not_use_vim (self, widget) :
		__is_activated = widget.get_active()
		self.xml.get_widget("entry13").set_property( \
			"sensitive", not __is_activated)

		return self.GCONF_CLIENT.set_value_by_conf( \
			"use-vim", not __is_activated)

	def on_not_use_gvim (self, widget) :
		__is_activated = widget.get_active()
		self.xml.get_widget("entry16").set_property( \
			"sensitive", not __is_activated)

		return self.GCONF_CLIENT.set_value_by_conf( \
			"use-gvim", not __is_activated)

	def on_not_use_terminal (self, widget) :
		__is_activated = widget.get_active()
		self.xml.get_widget("entry14").set_property( \
			"sensitive", not __is_activated)

		return self.GCONF_CLIENT.set_value_by_conf( \
			"use-terminal", not __is_activated)

	def on_change_timeout_screensaver (self, widget) :
		__value = widget.get_value()
		self.GCONF_CLIENT.set_value_by_conf( \
			"timeout-screensaver", \
			int(__value * (1000*60))
		)

	def on_enable_screensaver (self, widget) :
		__spin = self.xml.get_widget("spinbutton2")
		if not widget.get_active() :
			__spin.set_sensitive(False)
		else :
			__spin.set_sensitive(True)

		self.GCONF_CLIENT.set_value_by_conf( \
			"enable-screensaver", \
			widget.get_active()
		)

	def on_change_tab_position (self, widget) :
		__pos = widget.get_active()

		self.GCONF_CLIENT.set_value_by_conf( \
			"tab-position", \
			self.TAB_POSITION[__pos] \
		)

	def on_color_changed (self, widget, type) :
		__c = func.color_to_str(widget.get_color())
		self.GCONF_CLIENT.set_value_by_conf( \
			"color-%s" % (type), \
			__c
		)

	def on_change_terminal (self, widget) :
		self.GCONF_CLIENT.set_value_by_conf( \
			"command-terminal", \
			widget.get_text())

	def on_change_vim (self, widget) :
		self.GCONF_CLIENT.set_value_by_conf( \
			"command-vim", \
			widget.get_text())

	def on_change_gvim (self, widget) :
		self.GCONF_CLIENT.set_value_by_conf( \
			"command-gvim", \
			widget.get_text())

	def on_toggle_menubar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value_by_conf( \
			"show-menubar", __is_activated)

	def on_toggle_toolbar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value_by_conf("show-toolbar", __is_activated)

	def on_toggle_statusbar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value_by_conf("show-statusbar", __is_activated)

	def on_toggle_bookmark (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value_by_conf("show-bookmark", __is_activated)

	def on_font_set_vim (self, widget) :
		__font_name = widget.get_font_name()

		self.GCONF_CLIENT.set_value_by_conf("font-vim", __font_name)

	def on_font_set_terminal (self, widget) :
		__font_name = widget.get_font_name()

		self.GCONF_CLIENT.set_value_by_conf("font-terminal", __font_name)

	def on_use_system_font (self, widget) :

		__checkbutton = self.xml.get_widget("checkbutton12")

		__buttonFontVIM = self.xml.get_widget("fontbutton3")
		__buttonFontTerminal = self.xml.get_widget("fontbutton4")

		__labelFontVIM = self.xml.get_widget("label75")
		__labelFontTerminal = self.xml.get_widget("label76")

		if __checkbutton.get_active() :

			__buttonFontTerminal.set_sensitive(False)
			__buttonFontVIM.set_sensitive(False)

			__labelFontTerminal.set_sensitive(False)
			__labelFontVIM.set_sensitive(False)

			self.GCONF_CLIENT.set_value_by_conf( \
				"use-system-default-font", True)
		else :
			self.GCONF_CLIENT.set_value_by_conf( \
				"use-system-default-font", False)

			__buttonFontTerminal.set_sensitive(True)
			__buttonFontVIM.set_sensitive(True)

			__labelFontTerminal.set_sensitive(True)
			__labelFontVIM.set_sensitive(True)

	def on_change_max_scrollline (self, widget) :
		__value = widget.get_value()

		self.GCONF_CLIENT.set_value_by_conf( \
			"max-scrollline", int(__value))

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Window.py"

