# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, gettext as __gettext
import Conf

def gettext () :
	try :
		t = __gettext.translation("vee", Conf.DIR_LOCALE)
	except IOError :
		return __gettext.gettext
	else :
		return t.ugettext

def getDirectoryLocale (localedir) :
	# get locale environment value.

	envvars = ("LC_ALL", "LANG", "LC_MESSAGES", )

	for i in envvars :
		__v = os.getenv(i)

		if __v :
			envLocale = __v
			break

	langlist = __gettext._expand_lang(envLocale)
	for lang in langlist :
		if lang == "C" : return None

		__dir = os.path.join(localedir, lang)
		if os.path.exists(__dir) and os.path.isdir(__dir) :
			return __dir

	return None

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "i18n.py"


